PAPI_thread_init(3)

NAME
PAPI_thread_init - Initialize thread support in the PAPI library.

SYNOPSIS

Detailed Description

Parameters
    *id_fn Pointer to a function that returns current thread ID.

PAPI_thread_init initializes thread support in the PAPI library. Applications that make no use of threads do not need to call this routine. This function MUST return a UNIQUE thread ID for every new thread/LWP created. The OpenMP call omp_get_thread_num() violates this rule, as the underlying LWPs may have been killed off by the run-time system or by a call to omp_set_num_threads() . In that case, it may still possible to use omp_get_thread_num() in conjunction with PAPI_unregister_thread() when the OpenMP thread has finished. However it is much better to use the underlying thread subsystem's call, which is pthread_self() on Linux platforms.

if ( PAPI_thread_init(pthread_self) != PAPI_OK )
    exit(1);

See also
    PAPI_register_thread PAPI_unregister_thread PAPI_get_thr_specific PAPI_set_thr_specific PAPI_thread_id PAPI_list_threads

Author

Generated automatically by Doxygen for PAPI from the source code.